package jeu;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.swing.JPanel;

import entites.Chateau;
import entites.GroupeAliens;
import entites.TirVaisseau;
import entites.Vaisseau;
import ressources.Chrono;
import ressources.Clavier;
import ressources.Constantes;

public class Scene extends JPanel {
	
/**** VARIABLES ****/	
	
	public Vaisseau vaisseau = new Vaisseau();
	public GroupeAliens groupeAliens = new GroupeAliens();
	public TirVaisseau tirVaisseau = new TirVaisseau();
	
	public Chateau tabChateaux[] = new Chateau[4]; // Cration d'un tableau contenant les 4 chteaux
	
/**** CONSTRUCTEUR ****/
	
	public Scene() {
		super();
		
		// Instanciation des chteaux		
		for(int colonne=0; colonne<4; colonne++) {
			this.tabChateaux[colonne] = new Chateau(Constantes.MARGE_FENETRE + 
					Constantes.X_POS_INIT_CHATEAU + colonne * (Constantes.LARGEUR_CHATEAU + Constantes.ECART_CHATEAU));
		}
		
		
		// Instanciation du clavier
		this.setFocusable(true);
		this.requestFocusInWindow();
		this.addKeyListener(new Clavier());
		
		// Instanciation du chrono ( la fin du constructeur)
		Thread chronoEcran = new Thread(new Chrono());
		chronoEcran.start();
	}

		
/**** METHODES ****/
	
	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		Graphics g2 = (Graphics2D) g;
		
		// Dessin du fond d''cran
		g2.setColor(Color.BLACK);
		g2.fillRect(0, 0, Constantes.LARGEUR_FENETRE, Constantes.HAUTEUR_FENETRE);
		
		// Dessin ligne verte en bas de l'cran
		g2.setColor(Color.GREEN);
		g2.fillRect(30, 530, 535, 5);
		
		// Dessin du vaisseau
		this.vaisseau.dessinVaisseau(g2);
		
		// Dessin des aliens
		this.groupeAliens.dessinAliens(g2);
		
		// Dessin du tir vaisseau
		this.tirVaisseau.dessinTirVaisseau(g2);
		
		// Dtection contact tirVaisseau avec alien
		this.groupeAliens.tirVaisseauToucheAlien(this.tirVaisseau);
		
		// Dessin des chteaux
		for(int colonne=0; colonne<4; colonne++) {this.tabChateaux[colonne].dessinChateau(g2);}
		
		// Dtection contact tirVaisseau avec chteau
		this.tirVaisseau.tirVaisseauDetruitChateau(tabChateaux);	
	}
	
	
}
